#include "client.hpp"
#include "data.hpp"
#include "server.hpp"
#include <boost/log/trivial.hpp>
#include <cstring>

int main(int argc, char *argv[]) {
  if (argc < 2) {
    BOOST_LOG_TRIVIAL(fatal) << "not enough arguments!";
    return 1;
  }

  if (strcmp(argv[1], "serve") == 0) {
    server::run(data::getIpcKeyFromExeName(argv[0]));
  } else if (strcmp(argv[1], "map") == 0) {
    client::map(data::getIpcKeyFromExeName(argv[0]));
  } else if (strcmp(argv[1], "resourceloc") == 0) {
    client::resolveResourceLoc(data::getIpcKeyFromExeName(argv[0]));
  } else {
    BOOST_LOG_TRIVIAL(fatal) << "unknown command!";
    return 1;
  }

  return 0;
}
